################################################################
#
#   Assembly Line - Conveyor drive
#
################################################################

from pygame import Rect
from albow.resource import get_image
from albow.image_array import get_image_array
from machine import Machine

class ConveyorDrive(Machine):

	title = "Conveyor Drive"
	icon = get_image("conveyor_drive_icon.png")
	rotation_mask = 3
	layer = 0
	is_conveyor_drive = True
	cost = 200
	num_phases = 8

	orgx, orgy = -16, -16
	
	local_bounding_rect = Rect(orgx, orgy, 32, 32)

	local_covered_rects = [
		[local_bounding_rect],
		[]
	]

	images = get_image_array("conveyor_drive.png", 4, border = 2)
	
	phase = 0
	direction = 1
	running = True

	def draw_local(self, surf, t):
		org = self.local_topleft()
		t.draw_image(surf, self.images, org)

	def adjacent_direction(self):
		return self.global_vector((0, -1))

	def begin_frame(self, factory):
		if self.running:
			self.phase = (self.phase + self.direction) % self.num_phases
